
## $Id: csclib.pl,v 1.148 2000/05/12 19:32:05 muhri Exp $
use vars qw( %prefs $libpath );
use strict;
# if we're here, the libpath should be setup already

use DBI;
use Date::Manip;
use MIME::Words;


# 
# Set up default preferences
# 
$prefs{'HtmlAllowed'} = 'html head title body body:* body:bgcolor body:text body:link body:alink body:vlink h1 h2 h3 h4 a a:href hr hr:width table table:* table:width table:height table:border table:bgcolor table:cellspacing table:cellpadding tr tr:* tr:width tr:height tr:bgcolor tr:border tr:align tr:valign td:* td td:width td:height td:bgcolor td:rowspan td:colspan td:border td:align td:valign th th:* th:width th:height th:bgcolor b i u strong em font font:* font:color font:face font:style p br div div:align span span:style ul ol li center blockquote img img:* img:src';
# omitted tags: form input select option textarea iframe ilayer layer 

$prefs{'User'} = $ENV{"USER"};
$prefs{'MailDir'} = $ENV{"HOME"} . '/.cscmail';
$prefs{'HomePage'} = "http://www.cyberdeck.org/cscmail";
$prefs{'AutoCheckTime'}=10; # minutes
$prefs{'AddReplytoAB'}="n";
$prefs{'SortCol'} = '5';
$prefs{'SortDir'} = "ascending";
$prefs{'SendImmediately'}="y";
$prefs{'ForwardAttachments'} = "n";
$prefs{'FolderNewBold'}="y";
$prefs{'InlineImages'}="y";
$prefs{'InlineAttachments'}="y";
$prefs{'InlineIcons'}="y";
$prefs{'Scoring'} = "y";
$prefs{'HeaderBar'}="y";
$prefs{'Debug'} = 0;
$prefs{'DebugFile'} = "$prefs{'MailDir'}/cscmail.debug";
$prefs{'DocDir'} = $libpath . '/docs';
$prefs{'PixmapDir'} = $libpath . '/pixmaps/pro';
$prefs{'DatabaseDriver'} = "CSV";
$prefs{'DatabaseUser'} = "";
$prefs{'FontUIBold'} = '-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-1';
$prefs{'FontMLBold'} = '-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-1';
$prefs{'FontMessages'} = '-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1';
$prefs{'FontMLNormal'} = '-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1';
$prefs{'MarkAsReadDelay'} = 2; # seconds
$prefs{'QuoteHeader'} = "On %d, %n said:";
$prefs{'WrapAfter'} = 74;
$prefs{'DateDisplayFormat'} = '%M/%d/%y %h:%m';
# %M = month, %d = day, %y = 2 digit year, %Y = 4 digit year, %m = minute, %h = hour, %s = seconds
$prefs{'ViewerPath'} = "/usr/bin/netscape";
$prefs{'SendReceipt'} = "ask";
$prefs{'PrintCommand'} = "lpr";
$prefs{'QuoteWith'} = "> ";
$prefs{'saveSize'} = "y";
$prefs{'PlaySound'} = "n";
$prefs{'DeleteMarksAsRead'} = "n";
$prefs{'import'} = "n";
$prefs{'checkDupeOnAll'}='n';
$prefs{'ForwardHeader'}='y';
$prefs{'ispellpath'} = "/usr/bin/ispell";
$prefs{'autospell'} = "n";
$prefs{'toolbar'} = "y";
$prefs{'toolbarstyle'} = "both";
$prefs{'useAlternateViewer'} = "n";
$prefs{'attachLeftView'} = "n";
$prefs{'UseMessageColors'} = "y";
$prefs{'MessageColor'} = "000000";
$prefs{'QuoteColor1'} = "FF0000";
$prefs{'QuoteColor2'} = "0000FF";
$prefs{'QuoteColor3'} = "FF00FF";
$prefs{'QuoteSymbols'} = ">  ,> ,>";
$prefs{'MessageBgColor'} = "FFFFFF";
sub numerically { $a <=> $b; }

sub process_from {
	my $result;
	my $from = $_[0];
	$from =~ /\((.+)\)$/ and $result = $1;
	$from =~ /^(.+) <.+>/ and $result = $1;
	$from =~ /^\"(.+)\"/ and $result = $1;
	if (!$result) { $result = $from; }
	return $result;
}

sub save_prefs {
	open(FILE_PREFS, '>'. $ENV{"HOME"} . '/.cscmailrc');
	my $key;
	foreach $key (sort keys %prefs) {
		print FILE_PREFS "$key: $prefs{$key}\n";
	};
	close(FILE_PREFS);
	chmod(0600, $ENV{"HOME"} . '/.cscmailrc');
}

# we should have had one of these since the beginning...
# here it is... ERROR DIALOG!!! hehe  just call
# &err_dialog("your error here"); and you'll get a nice
# dialog popup...

sub err_dialog {
	my ($error) = @_;
	my ($dlg, $lbl, $ok);
	$dlg = new Gtk::Dialog;
	$dlg->signal_connect("destroy" => sub { $dlg->destroy; });
	$dlg->signal_connect("delete_event" => \&Gtk::false);
	$dlg->set_title("Error");
	$dlg->border_width(10);
	$dlg->position(-mouse);
	$dlg->set_default_size(150, 100);
	$lbl = new Gtk::Label "$error";
	$lbl->set_alignment(0.5,0.5);
	$lbl->set_line_wrap(1);
	$dlg->vbox->pack_start($lbl,1,1,5);
	$lbl->show;
	$ok = new Gtk::Button "Ok";
	$ok->signal_connect("clicked", sub { $dlg->destroy; });
	$ok->set_usize(55,25);
	$ok->show;
	$dlg->action_area->pack_start($ok,0,0,5);
	$dlg->show;
	return 1;
}

sub read_prefs {
	open(FILE_PREFS,  $ENV{"HOME"} . '/.cscmailrc') || return 0;
	while (<FILE_PREFS>) {
		if (m/^#/) { next; }
		if (m/^(\w+):\s+(.*)$/) { $prefs{$1} = $2; };
# for complete backwards compatibility with 1.3.5 .cscmailrc file
		if (m/^Database Driver:\s+(.*)$/) { $prefs{'DatabaseDriver'} = $1; };
		if (m/^AutoCheck Timeout:\s+(.*)$/) { $prefs{'AutoCheckTime'} = $1; };
	}
	return 1;
}

## Added debug and command-line flag handling <red@madhouse.org.uk>

## wr_debug("sometext") - appends a line or more to debug file.
sub wr_debug {
	if (!($prefs{'Debug'})) { return; }
	my $line_in = join('', @_);
	if ($prefs{'Debug'} & 2) {
		open(FILE_FD, '>>'.$prefs{'DebugFile'}) || die "Can't open debug file for writing: $!";
		print(FILE_FD "$line_in\n");
		close(FILE_FD);
	}
	if ($prefs{'Debug'} & 1) { print("$line_in\n"); }
}

## $tree = filename_to_tree($original_filename, $check_path); <red@madhouse.org.uk>
#  Function that translates the original filename into tree format.
#  Tree format is required as filesystems are horrifically inefficient
#  when we reach large numbers of files in a single directory.
#

sub filename_to_tree {
	my ($message_number, $first_dir, $second_dir, $filename, $start_path, @digits);
	my ($original_filename) = @_;
	$original_filename =~ /(.*)\/(\d+)/;
	$start_path = $1;
	$message_number = $2;
	@digits = split(//, $message_number);
	if ($#digits == 0) {
		$digits[1] = $digits[0];
		$digits[0] = 0;
		$message_number = "0$digits[1]";
	}
	$first_dir = $digits[$#digits];
	$second_dir = $digits[($#digits-1)];
	mkdir("$start_path/$first_dir", 0700);
	mkdir("$start_path/$first_dir/$second_dir", 0700);
	return("$start_path/$first_dir/$second_dir/$message_number.msg");
}

sub date_to_localdate {
	my ($date) = @_;
	$date =~ s/\r//g;
	$date =~ s/\\//g;
	$date =~ s/:(\d):/:0$1:/;
	$date =~ s/ (\d):/ 0$1:/;
	$date =~ s/:(\d)(\s|$)/:0$1$2/;
	$date =~ s/PM//i;
	$date =~ s/ 100 / 2000 /; # mutt?
	$date =~ s/ 0100 / 2000 /; # yeah there are some broken like that...
	$date =~ s/Pacific Daylight Time/PDT/i;
	$date =~ s/Eastern Standard Time/EST/i;
	$date =~ s/Eastern Daylight Time/EDT/i;
	$date =~ s/\"GMT\"/GMT/i;
	$date =~ s/US\/EASTERN/EST/i;
	$date =~ s/ -(\d\d\d)(\s|$)/ -0$1$2/i;
	$date =~ s/ fr/ GMT/i;
	$date =~ s/GMT([+|-])(\d)\b/${1}0${2}00/;
	$date =~ s/GMT([+|-])(\d\d)\b/${1}${2}00/;
	my $localdate = &UnixDate($date, "%s");
	if ($localdate) {
		return $localdate;
	} else {
		return $date;
	}
}


sub localdate_to_displaydate {
	my ($localdate) = @_;
	my $datestr = $prefs{'DateDisplayFormat'};
	if (defined $localdate && $localdate != 0) {
		my @tm = localtime($localdate);
		$tm[4]++; # increment month, it is originally 0-based
		my $shortyear = $tm[5] % 100; # convert year to two-digit
		$tm[5]+=1900;
		for (my $i = 0; $i<5; $i++) {
			$tm[$i] = sprintf("%.2d", $tm[$i]);
		}
		$shortyear = sprintf("%.2d", $shortyear);
		$datestr =~ s/%d/$tm[3]/g;
		$datestr =~ s/%M/$tm[4]/g;
		$datestr =~ s/%y/$shortyear/g;
		$datestr =~ s/%Y/$tm[5]/g;
		$datestr =~ s/%h/$tm[2]/g;
		$datestr =~ s/%m/$tm[1]/g;
		$datestr =~ s/%s/$tm[0]/g;
		return($datestr);
	}
	return "Invalid Date";
}

sub date_now {
	return &UnixDate("now", "%g");
}

sub open_db_conn {
	if ($prefs{'DatabaseDriver'} eq 'CSV') {
		return DBI->connect("DBI:$prefs{'DatabaseDriver'}:f_dir=$prefs{'MailDir'}", {AutoCommit => 1}) or die "Cannot create message database files in $prefs{'MailDir'}";
	} else {
		return DBI->connect("DBI:$prefs{'DatabaseDriver'}:dbname=$prefs{'User'}",$prefs{'DatabaseUser'},$prefs{'DatabasePassword'}, {AutoCommit => 1}) or die "Cannot connect to database $prefs{'User'} using $prefs{'DatabaseDriver'}. Make sure that you have installed and configured DBI drivers on this machine.";
	}
}

# this should always generate the LOWEST unique ID for a table... 
sub newid {
	my ($table_name, $conn) = @_;
	my ($query, @row);
	my $last = 0;
	$query=$conn->prepare("select id from $table_name order by id");
	$query->execute();
	while (@row=$query->fetchrow_array()) {
		if ($last == $row[0] || $last+1 == $row[0]) { $last = $row[0]; next; }
		return $last+1;
	}
	return $last+1;
}

## $isdupe=&checkForDupe($dbconnection, $messageid, $accountid);
##
## checks if the message $messageid is already dawnloaded (in $accountid)
## returns undef if it's no dupe
sub checkForDupe {
	my ($conn, $msgid, $accountid)=@_;
	my ($query, $sql, $row, $dupes);
	# okay, now lets check if the mail already exists
	if (defined $prefs{'checkDupeOnAll'} && $prefs{'checkDupeOnAll'} eq "y"){
		$sql="select * from messages where msgid=?";
		$query=$conn->prepare($sql);
		$query->execute($msgid);
	} else {
		$sql="select * from messages where msgid=? and accountid=?";
		$query=$conn->prepare($sql);
		$query->execute($msgid, $accountid);
	}
	$row=$query->fetchall_arrayref;
	$dupes=scalar(@{$row});
	&wr_debug("-- dupeCheck: $msgid ->".$dupes." dupes found");
	if ($dupes==0){
		$dupes=undef;		
	} 
	return $dupes;
}

## ($headerHash, $mailbody)=&parseHeader($rawmail)
##
## parses a email and return a hash for the header in style of
## $hash->{'subject'}="a subject";
## and the mail body in a string
## it returns undef on error
sub parseHeader {
	my ($rawmail)=@_;
	my ($rawheader, @rawheader, $header,$rawbody,$tmp);

	# parse out win crlf, you never know :)
	$rawmail=~s/\r\n/\n/g;
	if ($rawmail=~/(.+?)\n\n(.*)/s){
		$rawheader=$1; 
		$rawbody=$2; 
	} else {
		return undef;
	}
	# parse out trailing spaces (there shouldn't be ?)
	$rawheader=~ s/\n\s+/\n/g;
	@rawheader=split(/\n/, $rawheader);
	foreach (@rawheader){
		if (/(.+?):\s*(.*)/){
			$tmp=$1;
			$tmp=~tr/A-Z/a-z/;
			# fill the hash
			$header->{$tmp}=$2;
		} else {
			&wr_debug("invalid header line $_");
		}
	}
	return ($header, $rawbody);
}

sub save_message
{
	my ($conn, $rawbody, $filterref, $account) = @_;
	my %filter=%{$filterref};
	my ($query, $query2, $sql, $boxid, $match, $newsentfrom, $newsentto, $newsubject, $newcc, $newreplyto, $sql2, $tmp, $newid, @rawheader, $rawheader);
	my ($msgid, $date, $sentto, $sentfrom, $subject, $contenttype, $contentxferencode, $mimeversion, $precedence, $approvedby, $inreplyto, $replyto, $listsub, $listunsub, $status, $xorigip, $cc, $sender, $returnpath, $priority, $xmailer, $xsender, $sf_friendly, $localdate, $isnew,$receiptto,$score) = ('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '','','',0);

	$rawbody =~ s/^content-type:\s*text(\s)/Content-Type: text\/plain$1/im;
	$rawbody =~ /(.+?)\n\n/s and $rawheader = $1;
	$rawheader =~ s/\n\s+//g;
	@rawheader = split /\n/, $rawheader;
	foreach (@rawheader) {
		/^Message-Id:\s*(.+)/i and $msgid = $1;
		/^From:\s*(.+)/i and $sentfrom = $1;
		/^Date:\s*(.+)/i and $date = $1;
		/^To:\s*(.+)/i and $sentto = $1;
		/^Subject:\s*(.+)/i and $subject = $1;
		/^Content-Type:\s*(.+)/i and $contenttype = $1;
		/^Content-Transfer-Encoding:\s*(.+)/i and $contentxferencode = $1;
		/^Mime-Version:\s*(.+)/i and $mimeversion = $1;
		/^Precedence:\s*(.+)/i and $precedence = $1;
		/^Approved-By:\s*(.+)/i and $approvedby = $1;
		/^In-Reply-To:\s*(.+)/i and $inreplyto = $1;
		/^Reply-To:\s*(.+)/i and $replyto = $1;
		/^List-Subscribe:\s*(.+)/i and $listsub = $1;
		/^List-Unsubscribe:\s*(.+)/i and $listunsub = $1;
		/^Status:\s*(.+)/i and $status = $1;
		/^X-Originating-IP:\s*[(.+)]/i and $xorigip = $1;
		/^Cc:\s*(.+)/i and $cc = $1;
		/^Sender:\s*(.+)/i and $sender = $1;
		/^Return-Path:\s*<(.+)>/i and $returnpath = $1;
		/^X-MSMail-Priority:\s*(.+)/i and $priority = $1;
		/^X-Priority:\s*(.+)/i and $priority = $2;
		/^X-mailer:\s*(.+)/i and $xmailer = $1;
		/^X-Sender:\s*(.+)/i and $xsender = $1;
		if(/^Disposition-Notification-To:\s*(.+)/i && $receiptto eq "") { $receiptto=$1; }
		if(/^Return-Receipt-To:\s*(.+)/i && $receiptto eq "") { $receiptto=$1; }
		if(/^Read-Receipt-To:\s*(.+)/i && $receiptto eq "") { $receiptto=$1; }
		if(/^X-Confirm-reading-to:\s*(.+)/i && $receiptto eq "") { $receiptto=$1; }
		if(/^Return-Receipt-Requested:\s*(.+)/i && $receiptto eq "") { $receiptto=$1; }
		if(/^Register-Mail-Reply-Requested-By:\s*(.+)/i && $receiptto eq "") { $receiptto=$1; }
	}
	# test if message has already been downloaded
	# some POP servers set the Status: field in the header
	# i test for R or O (R message is read or downloaded./O message is old
	# but not deleted. 

	# the mighty dupecheck follows...
	if (defined $account->{'dupecheck'} && $account->{'dupecheck'} eq 'y'){
		# we want dupecheck...
		unless (defined $account->{'dupeworked'} && $account->{'dupeworked'} eq 'y'){
			# if we already dupe-checked, don't do it again
		  if (defined &checkForDupe($conn, $msgid, $account->{'id'})){
				# the message is a dupe... return successfully, so messages will get deleted...
				return "success";
			}	
		}
	}
	if ($status =~ /R/ || $status =~ /O/) {
		$isnew="n";
	} else {
		$isnew="y";
	}
	if (!$contenttype) { $contenttype = "text/plain"; }
	if ($sentfrom) {
		$sentfrom = MIME::Words::decode_mimewords($sentfrom);
		$sf_friendly = &process_from($sentfrom);
	}
	if ($subject) {
		$subject = MIME::Words::decode_mimewords($subject);
	}
	$localdate = &date_to_localdate($date);
	$boxid =1;
	$score=0;
	$match=0;
	foreach (sort numerically (keys(%filter))) {
		if ($filter{$_}->{type} == 0) { next; }
		if ($filter{$_}->{type} == 1 && $filter{$_}->{regex} == $account->{'id'}) { 
			$match = 1;
		} elsif ($filter{$_}->{type} == 2 && ($sentto =~ /$filter{$_}->{regex}/ || $cc =~ /$filter{$_}->{regex}/)) {
			$match = 1;
		} elsif ($filter{$_}->{type} == 3 && $subject =~ /$filter{$_}->{regex}/) {
			$match = 1;
		} elsif ($filter{$_}->{type} == 4 && $sentfrom =~ /$filter{$_}->{regex}/) {
			$match = 1;
		} elsif (($filter{$_}->{type} == 5 || $filter{$_}->{type} == 6) && $rawheader =~ /$filter{$_}->{regex}/m) {
			$match = 1;
		}
		if ($match == 1) {
			if ($filter{$_}->{type} != 6) {
				$boxid = $filter{$_}->{boxid};
			}
			if ($filter{$_}->{type} != 6 && $boxid == 2) {
				$newsentto = $filter{$_}->{addr};
				$newsubject = "Fw: " . $subject;
				$newsentfrom = "$account->{'friendly'} <$account->{'reply'}>";
				$newcc = "";
				$newreplyto = $account->{'reply'};
			} elsif ($filter{$_}->{type} == 6) {
				$score+=$filter{$_}->{boxid};
			} else {
				$newsentto = $sentto;
				$newsubject = $subject;
				$newsentfrom = $sentfrom;
				$newcc = $cc;
				$newreplyto = $replyto;
			}
		}
		$match = 0;
	}
	if ($newsubject) {$subject = $newsubject;}
	if ($newsentfrom) {$sentfrom = $newsentfrom;}
	if ($newcc) {$cc = $newcc;}
	if ($newreplyto) {$replyto = $newreplyto;}

	# some fields can be huge, e.g. sentto, and dbd:csv will not truncate them 
	# most real sql databases will truncate quietly to the size of varchar
	$sentto = substr($sentto, 0, 255);
	$cc = substr($cc, 0, 255);

	$sql2 = "insert into messages (id, msgid, boxid, accountid, date, sentto, sentfrom, subject, contenttype, contentxferencode, mimeversion, precedence, approvedby, inreplyto, replyto, listsub, listunsub, status, xorigip, cc, sender, returnpath, priority, xmailer, xsender, localdate, newmsg, friendly, rreceiptto, score)
			values 
		(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
	$query2=$conn->prepare($sql2);
	$newid = &newid('messages', $conn);
	$query2->execute($newid, $msgid, $boxid, $account->{'id'}, $date, $sentto, $sentfrom, $subject, $contenttype, $contentxferencode, $mimeversion, $precedence, $approvedby, $inreplyto, $replyto, $listsub, $listunsub, $status, $xorigip, $cc, $sender, $returnpath, $priority, $xmailer, $xsender, $localdate, $isnew, $sf_friendly, $receiptto, $score) or return undef;
	$tmp = filename_to_tree("$prefs{'MailDir'}/$newid", 1);
	wr_debug("Message file to be opened is: $tmp");
	open (TMP,">$tmp") or return undef;
	print TMP $rawbody;
	close(TMP);
	return "success";
}

sub read_from_mbox {
	my ($conn, $filterref, $statusbox, $account, $size, $marknew, $importbox)=@_;
	my $count = 0;
	system("csclock lock $account->{'srvr'}");
	if (defined $size and $size > 0 and $prefs{'PlaySound'} eq "y") { system("$prefs{'SndCmd'} $prefs{'SndFl'}"); }
        open(MBOX, "$account->{'srvr'}");
	$/ = "\n\nFrom ";
	my ($rawbody);
	my $delete_mbox_when_done = 1;
	while ($rawbody = <MBOX>) { # the msg can be huge, work with it in-place in a single var
		$count+=length($rawbody);    


                        if (defined $statusbox) {
			$statusbox->{'progressbar'}->set_value($count/1024);
			$statusbox->{'mailprogressbar'}->hide;
			while (events_pending Gtk) { main_iteration Gtk; }
		}
		
		
		if (defined $importbox) {
		$importbox->{'progressbar'}->set_value($count/1024);
		while (events_pending Gtk) { main_iteration Gtk; }
	       }
											    
		$rawbody =~ s/\nFrom $//s; # cut last line
		$rawbody =~ s/^.*\n//m; # cut first line

                 if (defined $marknew && $marknew eq "n"){
		     my ($header)=&parseHeader($rawbody);
		     # okay, we don't want to get the messages marked as new

		      
									   
		     if (defined $header->{'status'}){
		      # we already have a Status field, lets modify it
		       $rawbody=~s/\nStatus: (.+)\n/\nStatus: RO\n/;
		       } else {
		       $rawbody=~s/\n\n/\nStatus: RO\n\n/;
		       }
		}
		
                  
               
        
                 my $error=&save_message($conn, $rawbody, $filterref, $account);

		if (!defined $error){ $delete_mbox_when_done = 0; };

		open(TMP,">$prefs{'MailDir'}/.cscmail.refresh");
		print TMP ("1\n");
		close(TMP);

	}
	$/ = "\n";
	close(MBOX);
	if (($delete_mbox_when_done) and ($account->{'dm'} eq "y")) { open(MBOX, ">$account->{'srvr'}"); truncate(MBOX, 0); };
	system("csclock unlock $account->{'srvr'}");
        if(defined $importbox) { $importbox->destroy; }
}

my ($status_dialog);

sub import_from_mbox {
	my ($widget, $fswin, $list, $conn, $dir, $dirfile, $cscget)=@_;
	my ($sql, $query, $account, @row, %filter);
	if (defined $fswin) {
	$account->{'srvr'} = $fswin->get_filename();
	$fswin->destroy;
	    } else {
	   $account->{'srvr'} = "$dir/$dirfile";
	     
	      }
	      
	 if (not defined $cscget) {&init_import_sd;
	 my ($x,$y,$w,$h);
       	  $status_dialog->{'statuslabel'}->set_text("Importing to CSCMail format ...");
	   my ($percent);
	   $percent = 0;
	    $status_dialog->{'progressbar'}->set_value($percent);
	      while (events_pending Gtk) { main_iteration Gtk; }
	      
	   my  ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size)=stat $account->{'srvr'};
	  $size=$size/1024;
	    $status_dialog->{'progressbar'}->configure(0,0,$size);
	     $status_dialog->{'progressbar'}->set_format_string("%v of %u kbytes");
	       while (events_pending Gtk) { main_iteration Gtk; }
	       }
	

	$sql = "select * from filters";                                                                          
	$query=$conn->prepare($sql);
	$query->execute();
	while (@row = $query->fetchrow_array()) {
		$filter{$row[1]} = {
			'type' => $row[2],
			'boxid' => $row[3],
			'regex' => $row[4],
			'addr' => $row[5]
		}
	}
	$sql = "select id, friendly, reply from accounts where def = ?";
	$query=$conn->prepare($sql);
	$query->execute("y");
	($account->{'id'}, $account->{'friendly'}, $account->{'reply'}) = $query->fetchrow_array();
	($account->{'dm'} = "n");
	($account->{'dupecheck'}='y');
	unless (defined $account->{'id'} && $account->{'id'}){$account->{'id'}=1;}
	if (not defined $cscget) {
	my $size;
	&read_from_mbox($conn, \%filter, undef, $account,undef,$prefs{'import'}, $status_dialog, $size);
	$status_dialog->destroy;
	} else {
	&read_from_mbox($conn, \%filter, undef, $account, undef, undef, undef, undef);
	}
	return 1;
        
}



sub import_folder {
   my ($widget, $fswin, $list, $conn, $filename, $curfolder)=@_;
   my ($sql, $query,  $account, @row, %filter);
   $account->{'srvr'} = $fswin->get_filename();
   $fswin->destroy;
   &init_import_sd;
   my ($x,$y,$w,$h);
  
   $status_dialog->{'statuslabel'}->set_text("Importing to $curfolder ...");
   my ($percent);
   $percent = 0;
   $status_dialog->{'progressbar'}->set_value($percent);
   while (events_pending Gtk) { main_iteration Gtk; }
   
   my  ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size)=stat $account->{'srvr'};
   $size=$size/1024;
   $status_dialog->{'progressbar'}->configure(0,0,$size);
   $status_dialog->{'progressbar'}->set_format_string("%v of %u kbytes");
   while (events_pending Gtk) { main_iteration Gtk; }



   $sql = "select id from boxlist where name = '$curfolder'";
   $query = $conn->prepare($sql);
   $query->execute();
   my ($boxid) = $query->fetchrow_array();
   $filter{'move'}={
           'type'=>2,
	   'boxid'=>$boxid,
	   'regex'=>'.',
	    'addr'=>''};
				   
   $sql = "select id, friendly, reply from accounts where def = ?";
   $query=$conn->prepare($sql);
   $query->execute("y");
   ($account->{'id'}, $account->{'friendly'}, $account->{'reply'}) = $query->fetchrow_array();
   ($account->{'dm'} = "n");
   ($account->{'dupecheck'}='y');
    unless (defined $account->{'id'} && $account->{'id'}){$account->{'id'}=1;}
    &read_from_mbox($conn, \%filter, undef, $account,undef, $prefs{'import'}, $status_dialog, $size);
    $status_dialog->destroy;
    return 1;



}

sub write_to_mbox {
       
	my ($widget, $fswin, $list, $conn)=@_;
	my ($filename, $rawbody, $msgid, $tmp, $count, $i);
	$filename = $fswin->get_filename();
	$fswin->destroy;  
	 &init_import_sd;
	 my ($x,$y,$w,$h);
	  $status_dialog->{'statuslabel'}->set_text("Exporting to MBOX ...");
	   my ($percent);
	    $percent = 0;
	    $status_dialog->{'progressbar'}->set_value($percent);
	     while (events_pending Gtk) { main_iteration Gtk; }
	   
	 
	my $sql = "select id from messages";
	my $query = $conn->prepare($sql);
	$query->execute();
	$count = $query->rows();
       
        for ($i = 1; $i <= $count; $i++) {
	
	open(MBOX, ">$filename");
      
	 while (($msgid) = $query->fetchrow_array()) {

	 $status_dialog->{'progressbar'}->configure($i++,0,$count);
	 $status_dialog->{'progressbar'}->set_format_string("%v of %u messages");
	   
	   while (events_pending Gtk) { main_iteration Gtk; }		
	    $tmp = &filename_to_tree("$prefs{'MailDir'}/$msgid");
		open(TMP,"<$tmp");
	   
		undef $/;  
		$rawbody = <TMP>;
	
	
				 
		$/ = "\n";
		close(TMP);
		print MBOX "From $prefs{'User'} ". &date_now . "\n";
		print MBOX $rawbody;
		print MBOX "\n";
	}
	close(MBOX);
	}
$status_dialog->destroy;
}

sub export_folder {
 my ($widget, $fswin, $list, $conn, $curfolder, $foldername)=@_;
 my ($filename, $rawbody, $msgid, $tmp, $count, $i);
 $filename = $fswin->get_filename();
 $fswin->destroy;
 &init_import_sd;
 my ($x,$y,$w,$h);
 $status_dialog->{'statuslabel'}->set_text("Exporting folder $foldername ...");
  my ($percent);
  $percent = 0;
  $status_dialog->{'progressbar'}->set_value($percent);
  while (events_pending Gtk) { main_iteration Gtk; }
				     
  my $sql = "select id from messages where boxid = '$curfolder'";
  my $query = $conn->prepare($sql);
  $query->execute();
  $count = $query->rows();
  for ($i = 1; $i <= $count; $i++) {
  
    open(MBOX, ">$filename/$foldername");
     while (($msgid) = $query->fetchrow_array()) {
       $status_dialog->{'progressbar'}->configure($i++,0,$count);
        $status_dialog->{'progressbar'}->set_format_string("%v of %u messages");
      while (events_pending Gtk) { main_iteration Gtk; }
      
      $tmp = &filename_to_tree("$prefs{'MailDir'}/$msgid");
       open(TMP,"<$tmp");
        undef $/;
	$rawbody = <TMP>;

        					 
	$/ = "\n";
	close(TMP);
        print MBOX "From $prefs{'User'} ". &date_now . "\n";
        print MBOX $rawbody;
        print MBOX "\n";
	    }
        close(MBOX);
}
$status_dialog->destroy;
 }
									     

sub text2html {
	my ($message, $arrayref) = @_;
	my ($header, $tail, @imageurls, $image, $url);
	$image = "";
	if (defined $arrayref) {
		@imageurls = @{$arrayref};
		foreach (@imageurls) {
			$url = "$prefs{'MailDir'}/tmp/$_";
			$image = $image . "<p>$_<br><img src=\"$url\"></p>";
		}
	}
	if($prefs{'UseMessageColors'} eq 'y') {
		$header = "<html>\n<body>\n<body bgcolor=$prefs{'MessageBgColor'}>\n<font color=#$prefs{'MessageColor'}>\n";
		$tail = "</font></body>\n</html>\n";
	}
	else {
		$header = "<html>\n<body>\n";
		$tail = "</body>\n</html>\n";
	}
	$message =~ s/</&lt;/g;
	$message =~ s/>/&gt;/g;
	$message =~ s/\t/&nbsp;/g;
	$message =~ s/ /&nbsp;/g;
	$message =~ s/\bhttp:\/\/([-_=&#;:%a-zA-Z0-9.~\/\?\$\+\@]+)/<a href=http:\/\/$1>http:\/\/$1<\/a>/g;
	$message =~ s/\bftp:\/\/([-_=&#;:%a-zA-Z0-9.~\/\?\$\+]+)/<a href=ftp:\/\/$1>ftp:\/\/$1<\/a>/g;
	$message =~ s/\bmailto:([-_a-zA-Z0-9.]+\@[-_a-zA-Z0-9.]+\.[-_a-zA-Z0-9]+)/<a href=mailto:$1>$1<\/a>/g;
	$message =~ s/([\s|;])([-_a-zA-Z0-9.]+\@[-_a-zA-Z0-9.]+\.[-_a-zA-Z0-9]+)/$1<a href=mailto:$2>$2<\/a>/g;
	$message =~ s/\.<\/a>/<\/a>\./g;
	$message =~ s/&gt;>/>/g;
	$message =~ s/&gt;<\/a>/<\/a>&gt;/g;
	$message =~ s/\"/&quot;/g;
	if($prefs{'UseMessageColors'} eq 'y') {
		my(@lines,@symbols,$numSymbols,$symbol,$line,@color,$temp,$continue,$sum,$i,$j);
		$message =~ s/\n/<\/font>&nbsp;<br>\n<font color=#$prefs{'MessageColor'}>/g;
		@symbols = split(/,/,$prefs{'QuoteSymbols'});
		$numSymbols = scalar(@symbols);
		for($i=1;$i<$numSymbols;$i++) {
			for($j=$i;$j>0 && length($symbols[$j]) > length($symbols[$j-1]);$j--) {
				$temp = $symbols[$j];
				$symbols[$j] = $symbols[$j-1];
				$symbols[$j-1] = $temp;
			}
		}
		@lines = split(/\n/,$message);
                $color[0] = $prefs{'QuoteColor1'};
                $color[1] = $prefs{'QuoteColor2'};
		$color[2] = $prefs{'QuoteColor3'};
		$message = "";
		foreach $line (@lines) {
			$sum = 0;
			$continue = 1;
			$temp = $line;
			while($continue) {
				$continue = 0;
				foreach $symbol (@symbols) {
					$symbol =~ s/>/&gt;/g;
					$symbol =~ s/</&lt;/g;
					$symbol =~ s/ /&nbsp;/g;
					if($temp =~ /<font color=#$prefs{'MessageColor'}>$symbol/) {
						$temp =~ s/<font color=#$prefs{'MessageColor'}>$symbol/<font color=#$prefs{'MessageColor'}>/g;
						$sum++;
						$continue = 1;
						last;			
					}
				}
			}
			if($sum!=0) {
                                $line =~ s/<font color=#$prefs{'MessageColor'}>/<font color=#$color[$sum%3]>/g;
                        }
			$message = "$message$line\n";
		}
	}
	else {
		$message =~ s/\n/&nbsp;<br>\n/g;
	}
	$message = $header . $message . $image . $tail;
	return $message;
}



sub init_import_sd {
  my ($sd_pbar, $sd_label, $sd_button, $sd_vbox);
        $status_dialog = new Gtk::Dialog;
        $status_dialog->signal_connect("destroy" => sub { $status_dialog->destroy; });
        $status_dialog->signal_connect("delete_event" => sub { $status_dialog->destroy; });
        $status_dialog->set_title("Transfer in progress  ...");
        $status_dialog->position(-mouse);
        $status_dialog->border_width(5);
        $sd_vbox=new Gtk::VBox(0,5);
        $sd_vbox->border_width(5);
        $status_dialog->vbox->pack_start($sd_vbox,1,1,0);
        $sd_vbox->show;
        $status_dialog->{'statuslabel'}=new Gtk::Label "Preparing ...";
        $status_dialog->{'statuslabel'}->set_alignment(0.5,0.5);
        $sd_vbox->pack_start($status_dialog->{'statuslabel'},0,1,0);
        $status_dialog->{'statuslabel'}->show;
        $status_dialog->{'progressbar'}=new Gtk::ProgressBar;
        $status_dialog->{'progressbar'}->set_usize(200,20);
        $status_dialog->{'progressbar'}->set_show_text(1);
        $status_dialog->{'progressbar'}->set_text_alignment(0.5,0.5);
        $status_dialog->{'progressbar'}->set_format_string("message %v of %u");
        $status_dialog->{'progressbar'}->configure(0,0,0);
        $sd_vbox->pack_start($status_dialog->{'progressbar'},1,1,0);
        $status_dialog->{'progressbar'}->show;
        $sd_button=new Gtk::Button "Hide Status";
        $sd_button->signal_connect("clicked" => sub { $status_dialog->destroy; });
        $sd_button->can_default(1);
        $status_dialog->action_area->pack_start($sd_button,1,1,0);
        $sd_button->grab_default;
        $sd_button->show;
        $status_dialog->show;
        while (events_pending Gtk) { main_iteration Gtk; }
        return 1;
}







1;
